<?php
 # mchallis says "session_start is required for the captcha-image to function,
 # and must be at the very top of the PHP script."
 # session_start() must be processed before any other output
 # or you might get a warning "headers already sent".
  if( !isset( $_SESSION ) ) {
    session_start();
  }
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
        <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
        <meta name="description" content="Contact Form" />
        <meta name="keywords" content="Contact form, contact, form" />
        <meta name="language" content="en-us" />

        <title>Contact Us</title>
        <style type="text/css" media="screen" >
                /* Sample CSS */
                #contactform {
                        font-family: verdana;
                        width: 600px;
                }

                #contactform h1 {
                        font-size: 130%;
                }

                #contactform img {
                        border: 0px;
                }

                #contactform .errors {
                        color: #ff0000;
                }

                #contactform .correct {
                        color: black;
                }

                #contactform legend {
                        font-size: 120%;
                        font-weight: bold;
                }

                #contactform .title {
                        color: black;
                        font-weight: bold;
                        font-size: 90%;
                        margin-top: 2px;
                        margin-bottom: 5px;
                }

                #contactform .field {
                        color: black;
                        font-size: 90%;
                        margin-bottom: 7px;
                }

                #contactform .small {
                        font-size: 100%;
                }

                #contactform .thanks {
                        margin-top: 15px;
                        color: green;
                        font-size: 105%;
                        margin-bottom: 15px;
                }
        </style>
</head>
<body>

<!-- To add into your own page TRIM beginning here -->

<div id="contactform">

<h1>Contact Us</h1>

<?php
//error_reporting(E_ALL ^ E_NOTICE); // Report all errors except E_NOTICE warnings
//error_reporting(E_ALL); // Report all errors and warnings (very strict, use for testing only)
//error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED) // E_DEPRECATED was added in 5.3 
//ini_set('display_errors', 1); // turn error reporting on
//ini_set('log_errors', 1); // log errors
//ini_set('error_log', dirname(__FILE__) . '/error_log.txt'); // where to log errors
/*
PHP script by Mike Challis, www.642weather.com/weather/scripts.php
Script available at http://www.642weather.com/weather/scripts/contact-form.zip
Required library:
http://www.642weather.com/weather/scripts/captcha-secureimage.zip
Contact Mike - http://www.642weather.com/weather/contact_us.php

Version: 1.4 - 28-Jan-2010 see changelog.txt for changes

You are free to use and modify the code

This php code provided "as is", and Long Beach Weather (Michael Challis)
disclaims any and all warranties, whether express or implied, including
(without limitation) any implied warranties of merchantability or
fitness for a particular purpose.

Copyright (C) 2008-2010 Mike Challis  (http://www.642weather.com/weather/contact_us.php)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

PHP version 4.3.9 or greater is recommended
NOTE: This script requires PHP installed using GD image support.
http://us2.php.net/manual/en/ref.image.php

*/
$contact_version = 'Version: 1.4 - 28-Jan-2010 - contact.php';

#################
// begin settings
#################

// ALWAYS configure these options before use
// ALWAYS test your contact form after making changes

// Email Contacts
// If you need to add more, carefully copy a line and add it below,
// modify the CONTACT and EMAIL values inside the single quotes.
// If you only want one, delete or comment out all but one array('CONTACT'... line
// Be careful not to break the array syntax
// Add as many contacts as you need, the drop down list will be made automatically

$contacts = array ( // <-- this must remain before your contact array

//array('CONTACT' => 'Joe Somebody',  'EMAIL' => 'joesomebody@yourwebsite.com'),
array('CONTACT' => 'Webmaster',     'EMAIL' => 'somebodyelse@yourwebsite.com'),

); // <-- this must remain after your contact array

// Email address(s) to receive Bcc (Blind Carbon Copy) messages
// Yes you can send to multiple emails, both methods are acceptable
// $email_address_bcc = 'user@example.com';
// $email_address_bcc = 'user@example.com, anotheruser@example.com';
$email_address_bcc = ''; // optional

// Normally this setting will be left blank, like this: $email_on_this_domain = '';
// Some Web hosts do not allow your PHP to send email unless the From: email address
// is from the same domain. If your form does not seem to be sending any email, then
// set this to your email address on the SAME domain as your web site as a possible workaround
$email_on_this_domain = ''; // optional

// Name of this file
// If you rename this file, you must change this or the form will not work
$file_name = 'contact.php';

// Site Name / Title
$sitename = 'Your Site Name';

// Site Domain without the http://www like this: $domain = '642weather.com';
// Can be a single domain:      $domain = '642weather.com';
// Can be an array of domains:  $domain = array('642weather.com','someothersite.com');
$domain = 'yoursite.com';

// Make sure the form was posted from your host name only.
// SET  $domain_protect =1; for ON,  $domain_protect = 0; for OFF.
// This is a security feature to prevent spammers from posting from files hosted on other domain names
// "Input Forbidden" message will result if host does not match
$domain_protect = 1;

// Double E-mail entry is optional
// enabling this requires user to enter their email two times on the contact form.
// SET  $enable_double_email = 1;  ON,  $enable_double_email = 0; for OFF.
$enable_double_email = 0;

// Fieldset Border is optional
// enabling this adds a border line around the contact form.
// SET  $ctf_border_enable = 1;  ON,  $ctf_border_enable = 0; for OFF.
$ctf_border_enable = 0;

// CAPTCHA is optional but recommended to prevent spam bots from spamming your contact form
// SET  $enable_captcha = 1;  ON,  $enable_captcha = 0; for OFF.
$enable_captcha = 1;

// Enable streaming MP3 audio of CAPTCHA code using Flash
// REQUIRES SecureImage Library version 2
// http://www.642weather.com/weather/scripts/captcha-secureimage.zip
// SET  $enable_captcha_audio_flash = 1;  ON,  $enable_captcha_audio_flash = 0; for OFF.
$enable_captcha_audio_flash = 1;

// CAPTCHA library [path]/[folder] (do not end with slash!)
// Suggested use: You can have one captcha-secureimage library in the root of your Web site
// sharing many contact forms in other folders as long as you correctly set the relative [path] for each contact form
$captcha_library = './captcha-secureimage';

// You can ban known IP addresses
// SET  $enable_ip_bans = 1;  ON,  $enable_ip_bans = 0; for OFF.
$enable_ip_bans = 0;

// Add IP addresses to ban here:  (be sure to SET  $enable_ip_bans = 1; to use this feature
$banned_ips = array(
'22.22.22.22', // example (add, change, or remove as needed)
'33.33.33.33', // example (add, change, or remove as needed)
);

// Wordwrap E-Mail message text so lines are no longer than 70 characters.
// SET  $wrap_message = 1;  ON,  $wrap_message = 0; for OFF.
$wrap_message = 1;

// Content-language for email message header
$ctf_language = 'en-us';

// Charset for email message header
$ctf_charset = 'iso-8859-1';

// Content-transfer-encoding for email message header
$ctf_encoding = 'quoted-printable';

// Redirect to Home Page after message is sent
// SET  $ctf_redirect_enable = 1;  ON,  $ctf_redirect_enable = 0; for OFF.
$ctf_redirect_enable = 0;
// Used for the delay timer once the message has been sent
$ctf_redirect_timeout = 3; // time in seconds to wait before loading another Web page
// Web page to send the user to after the time has expired
$ctf_redirect_url = 'index.php';

// The $welcome_intro is what gets printed when the form is first presented.
// It is not printed when there is an input error and not printed after the form is completed
$welcome_intro = <<<EOT

<p>
<b>Compliments are always welcome.<br />
Where are you from?
How did you find this site?</b>
</p>

<p>
For faster service, please include your name and email address in all
correspondence where you need a reply.
</p>

<p>
If your subject looks like spam, chances are it will be deleted by our spam filter or
ignored until we are not busy. Be specific. If there is an error message, include
the error message, and include the steps you tried before you had the problem.
Be polite.
</p>

<p>
If your question is answered and was helpful, it's always nice to know.
Saying thank you is always appreciated.
</p>

EOT;
// do not remove the above EOT line

// The $thank_you is what gets printed after the form is sent.
$thank_you = <<<EOT

 <h1>Message Sent</h1>

 <p align="left">
    Your message has been sent, thank you.
 </p>

EOT;
// do not remove the above EOT line

#################
// end settings
#################

#####                                                                      #####
# Do not alter any code below this point in the script or it may not run properly.
#####                                                                      #####

if ($ctf_redirect_enable) {

 $thank_you .= <<<EOT

<script type="text/javascript" language="javascript">
<!--
var count=$ctf_redirect_timeout;
var time;
function timedCount() {
  document.title='Redirecting in ' + count + ' seconds';
  count=count-1;
  time=setTimeout("timedCount()",1000);
  if (count==-1) {
    clearTimeout(time);
    document.title='Redirecting ...';
    self.location='$ctf_redirect_url';
  }
}
window.onload=timedCount;
//-->
</script>

<img src="./ctf-loading.gif" alt="Returning to Home Page" />&nbsp;&nbsp;
Returning to Home Page...

EOT;
// do not remove the above EOT line

}

// Test for some required things, print error message if not OK.
$requires = 'ok';
if(!function_exists('mail')) {
   echo '<p class="errors">ERROR: The PHP mail() function is not enabled in PHP!</p>';
   echo '<p>Contact your web host and ask them why the mail() function is not enabled for PHP.</p>';
   $requires = 'fail';
}

if ($enable_captcha) {
    if ( !extension_loaded("gd") ) {
       echo '<p class="errors">ERROR: GD image support not detected in PHP!</p>';
       echo '<p>Contact your web host and ask them why GD image support is not enabled for PHP.</p>';
       $requires = 'fail';
    }
    if ( !function_exists("imagepng") ) {
       echo '<p class="errors">ERROR: imagepng function not detected in PHP!</p>';
       echo '<p>Contact your web host and ask them why the imagepng function is not enabled for PHP.</p>';
       $requires = 'fail';
    }
    if ( !@strtolower(ini_get('safe_mode')) == 'on' && !file_exists("$captcha_library/securimage.php") ) {
       echo '<p class="errors">ERROR: captcha_library not found</p>';
       echo '<p>Did you install the required captcha_library?<br />
       Required library:<br />
       http://www.642weather.com/weather/scripts/captcha-secureimage.zip<br />
       Check that it is installed and the setting $captcha_library file path is set properly inside this script.</p>';
       $requires = 'fail';
    }
}

if ($requires == 'fail') {
  exit;
}

// add numbered keys starting with 1 to the $contacts array
$cont = array();
$ct = 1;
foreach ($contacts as $v)  {
    $cont["$ct"] = $v;
    $ct++;
}
$contacts = $cont;
unset($cont);

// initialize vars
$error = 0;
$error_print = '';
$message_sent = 0;
$mail_to    = '';
$to_contact = '';

$name       = '';
$email      = '';
$email2     = '';
$subject    = '';
$text       = '';
$code       = '';
// add another field here like above

$error_captcha = '';
$error_contact = '';
$error_name    = '';
$error_email   = '';
$error_email2  = '';
$error_subject = '';
$error_text    = '';
// add another field here like above

// process form now
if (isset($_POST['action']) && ($_POST['action'] == 'send')) {

    // check all input variables
    $cid = ctf_clean_input($_POST['CID']);
    if(empty($cid)) {
       $error = 1;
       $error_contact = 'Selecting a contact is required.';
    }
    else if (!isset($contacts[$cid]['CONTACT'])) {
        $error = 1;
        $error_contact = 'Requested Contact not found.';
    }
    $mail_to    = ctf_clean_input($contacts[$cid]['EMAIL']);
    $to_contact = ctf_clean_input($contacts[$cid]['CONTACT']);


    $name    = ctf_name_case(ctf_clean_input($_POST['name']));
    $email   = strtolower(ctf_clean_input($_POST['email']));
    if ($enable_double_email) {
       $email2   = strtolower(ctf_clean_input($_POST['email2']));
    }
    $subject = ctf_name_case(ctf_clean_input($_POST['subject']));
    $text    = ctf_clean_input($_POST['text']);
    $code    = ctf_clean_input($_POST['code']);
    // add another field here like above

    // check posted input for email injection attempts
    // fights common spammer tactics
    // look for newline injections
    ctf_forbidifnewlines($name);
    ctf_forbidifnewlines($email);
    if ($enable_double_email) {
       ctf_forbidifnewlines($email2);
    }
    ctf_forbidifnewlines($subject);

    // look for lots of other injections
    $forbidden = 0;
    $forbidden = ctf_spamcheckpost();
    if ($forbidden) {
       echo "<h1>Input Forbidden</h1>";
       exit;
    }

   // check for banned ip
   if( $enable_ip_bans && in_array($_SERVER['REMOTE_ADDR'], $banned_ips) ) {
      echo "<h1>Your IP is Banned</h1>";
      exit;
   }

   // CAPS Decapitator
   if (!preg_match("/[a-z]/", $text)) {
      $text = ctf_name_case($text);
   }

   if(empty($name)) {
       $error = 1;
       $error_name = 'Your name is required.';
   }
   if (!ctf_validate_email($email)) {
       $error = 1;
       $error_email = 'A proper email address is required.';
   }
   if ($enable_double_email && !ctf_validate_email($email2)) {
       $error = 1;
       $error_email2 = 'A proper email address is required.';
   }
   if ($enable_double_email && ($email != $email2) ) {
       $error = 1;
       $error_double_email = 'The two email addresses did not match, please enter again.';
   }
   if(empty($subject)) {
       $error = 1;
       $error_subject = 'Subject title is required.';
   }
   if(empty($text)) {
       $error = 1;
       $error_text = 'Message text is required.';
   }
   // add another field here like 4 lines above (only if you want it to be required)

  // begin captcha check if enabled
  // captcha is optional but recommended to prevent spam bots from spamming your contact form
  if ($enable_captcha) {
    if (!isset($_SESSION['securimage_code_value']) || empty($_SESSION['securimage_code_value'])) {
          $error = 1;
          $error_captcha = 'Could not read CAPTCHA cookie. PHP sessions could be broken. Also make sure you have cookies enabled and not blocking in your web browser settings.';
    }else{
          if(empty($code)) {
                $error = 1;
                $error_captcha = 'A CAPTCHA phrase is required.';
          } else {
                  require_once "$captcha_library/securimage.php";
                  $img = new Securimage();
                  $valid = $img->check("$code");
                  // Check, that the right CAPTCHA phrase has been entered, display an error message otherwise.
                  if($valid == true) {
                          // ok can continue
                  } else {
                          $error = 1;
                          $error_captcha = 'You entered in the wrong CAPTCHA phrase.<br />Sometimes the letters are hard to read. Please try again';
                  }
          }
    }
  } // end if enable captcha
  // end captcha check

  if (!$error) {

     // ok to send the email, so prepare the email message
     // lines separated by \n on Unix and \r\n on Windows
     if (!defined('PHP_EOL')) define ('PHP_EOL', strtoupper(substr(PHP_OS,0,3) == 'WIN') ? "\r\n" : "\n");

     $subj = "$sitename contact: $subject";

     $msg =  "Sent from $sitename contact form

To: $to_contact

From:
$name
$email

Message:
$text

";
// add another field here (in the $msg code above)

      // add some info about sender to the email message
      $userdomain = '';
      $userdomain = gethostbyaddr($_SERVER['REMOTE_ADDR']);
      $user_info_string  = "Sent from (ip address): ".$_SERVER['REMOTE_ADDR']." ($userdomain)" . PHP_EOL;
      $user_info_string .= "Coming from (referer): ".$_SERVER['HTTP_REFERER'] . PHP_EOL;
      $user_info_string .= "Using (user agent): ".ctf_clean_input($_SERVER['HTTP_USER_AGENT']) . PHP_EOL . PHP_EOL;
      $msg .= $user_info_string;

      // wordwrap email message
      if ($wrap_message) {
             $msg = wordwrap($msg, 70);
          }

      // remove some characters that mess up From: $name <$email>
      // remove single quote, double quote, semicolon, colon, comma
      $name = ctf_name_case(preg_replace(array ( '/\'/', '/"/', '/;/', '/:/', '/,/' ), '', $name));

      // prepare the email header
      if ($email_on_this_domain != '') {
           $header =  "From: $email_on_this_domain" . PHP_EOL;
      } else {
           $header =  "From: $name <$email>" . PHP_EOL;
      }
      if ($email_address_bcc !='') $header .= "Bcc: " . $email_address_bcc . PHP_EOL;
      $header .= "Reply-To: $email" . PHP_EOL;
      $header .= "Return-Path: $email" . PHP_EOL;
      $header .= 'MIME-Version: 1.0' . PHP_EOL;
      $header .= 'Content-type: text/plain; Content-language: '.$ctf_language.'; charset="'.$ctf_charset.'"' . PHP_EOL;
      $header .= 'Content-transfer-encoding: '.$ctf_encoding . PHP_EOL;

      // send the email
      ini_set('sendmail_from', $email); // needed for some windows servers
      mail($mail_to,$subj,$msg,$header);
      ini_restore('sendmail_from');     // needed for some windows servers

      $message_sent = 1;

   } // end if ! error
} // end if posted action = send

if($message_sent) {
      // thank you mesage is printed here
      echo $thank_you;
      echo "\n</div>";
}else{
      if (!$error) {
        // welcome intro is printed here unless message is sent
        echo $welcome_intro;
      }

echo "<!-- $contact_version -->\n";
echo "<!-- http://www.642weather.com/weather/scripts.php -->\n\n";

if ($ctf_border_enable) { 
echo '
<form action="' . ctf_output_string($file_name) . '" id="contact_us" method="post">

<fieldset>
        <legend>Contact Form</legend>';
}else{

echo '
<form action="' . ctf_output_string($file_name) . '" id="contact_us" method="post">
';
}

// print any input errors
if ($error) {
    $error_print .= '<p class="errors">Please make corrections below and try again.</p>'."\n";
    echo $error_print;
}



if (count($contacts) > 1) {

     echo '        <div class="title">
                <label for="CID">Department to Contact:</label>
        </div> '.echo_if_error($error_contact).'
        <div class="field">
                <select id="CID" name="CID">
';

    echo '                        <option value="">Select</option>'."\n";

     if ( !isset($cid) ) {
          $cid = $_GET['CID'];
     }

     $selected = '';

      foreach ($contacts as $k => $v)  {
          if (!empty($cid) && $cid == $k) {
                    $selected = 'selected="selected"';
          }
          echo '                        <option value="' . $k . '" ' . $selected . '>' . $v[CONTACT] . '</option>' . "\n";
          $selected = '';
      }

      echo '            </select>
      </div>' . "\n";
}
else {

     echo '<input type="hidden" name="CID" value="1" />'."\n";

}

echo '
        <div class="title">
                <label for="name">Name: </label>
        </div> '.echo_if_error($error_name).'
        <div class="field">
                <input type="text" id="name" name="name" value="' . ctf_output_string($name) .'" size="40" />
                <br /><span class="small">Please enter your name.</span>
        </div>';
if ($enable_double_email) {
 echo'
        <div class="title">
        <label for="email">Email Address: </label>
        </div> '.echo_if_error($error_email).'
         '.echo_if_error($error_double_email).'
        <div class="field">
                <input type="text" id="email" name="email" value="' . ctf_output_string($email) . '" size="40" />
        </div>
        <div class="title">
        <label for="email2">Email Address again: </label>
        </div> '.echo_if_error($error_email2).'
        <div class="field">
                <input type="text" id="email2" name="email2" value="' . ctf_output_string($email2) . '" size="40" />
                <br /><span class="small">Please enter your email address a second time to ensure is correct.</span>
        </div>
        ';

 } else {
echo'
        <div class="title">
                <label for="email">Email Address: </label>
        </div> '.echo_if_error($error_email).'
        <div class="field">
                <input type="text" id="email" name="email" value="' . ctf_output_string($email) . '" size="40" />
                <br /><span class="small">Please ensure your email address is correct.</span>
        </div>';

}



echo   '     <div class="title">
                        <label for="subject">Subject: </label>
        </div> '.echo_if_error($error_subject).'
        <div class="field">
                <input type="text" id="subject" name="subject" value="' . ctf_output_string($subject) . '" size="40" />
        </div>

        <!-- add another field here (similar to the title and field div code above
        be sure to change the label, id, name, string name, and error_[string name]) -->

        <div class="title">
                <label for="message">Message: </label>
        </div> '.echo_if_error($error_text).'

        <div class="field">
                <textarea id="message" name="text" cols="40" rows="8">' . ctf_output_string($text) . '</textarea>
                <br />
                <span class="small">(Information provided here will only be used in responding to your questions)</span>
        </div>
';

# captcha is optional but recommended to prevent spam bots from spamming your contact form
if ($enable_captcha) {

echo '
        <div class="title">
                <label for="code">Code from the image below:</label>
        </div>  '.echo_if_error($error_captcha).'
        <div class="field">
                <input id="code" name="code" type="text" />
        </div>

        <div style="width: 430px;  height: 55px">
         <img id="siimage" style="padding-right: 5px; border-style: none; float:left;"
         src="'.$captcha_library.'/securimage_show.php?sid='.md5(uniqid(time())).'"
         alt="CAPTCHA Image" title="CAPTCHA Image" />';

    if($enable_captcha_audio_flash) {
        echo '
        <object type="application/x-shockwave-flash"
                data="'.$captcha_library.'/securimage_play.swf?audio='.$captcha_library.'/securimage_play.php&amp;bgColor1=#8E9CB6&amp;bgColor2=#fff&amp;iconColor=#000&amp;roundedCorner=5"
                id="SecurImage_as3" width="19" height="19" align="middle">
			    <param name="allowScriptAccess" value="sameDomain" />
			    <param name="allowFullScreen" value="false" />
			    <param name="movie" value="'.$captcha_library.'/securimage_play.swf?audio='.$captcha_library.'/securimage_play.php&amp;bgColor1=#8E9CB6&amp;bgColor2=#fff&amp;iconColor=#000&amp;roundedCorner=5" />
			    <param name="quality" value="high" />
			    <param name="bgcolor" value="#ffffff" />
		</object>
              <br />';
   }else{
      echo '
      <a href="'.$captcha_library.'/securimage_play.php">
         <img src="'.$captcha_library.'/images/audio_icon.gif" alt="CAPTCHA Audio" title="CAPTCHA Audio"
          style="border-style: none; vertical-align:top; border-style: none;" onclick="this.blur()" /></a>
          <br />';
   }
      echo '<a href="#" style="border-style: none"
         onclick="document.getElementById(\'siimage\').src = \''.$captcha_library.'/securimage_show.php?sid=\' + Math.random(); return false">
         <img src="'.$captcha_library.'/images/refresh.gif" alt="Refresh Image" title="Refresh Image"
         style="border-style: none; vertical-align:bottom;" onclick="this.blur()" /></a>
        </div>';

}

echo '
<p>
        <input type="hidden" name="action" value="send" />
        <input type="submit" value="submit" />
</p>
        <div class="thanks">
                Thanks for taking the time to submit a comment or question.
        </div>
';
if ($ctf_border_enable) {
echo '</fieldset>
';
}
echo '</form>
</div>';
}

function echo_if_error($this_error){
  global $error;
  if ($error) {
    if (!empty($this_error)) {
         return '<span class="errors">' . $this_error . '</span>'."\n";
    }
  }
}

// functions for protecting and validating form input vars
function ctf_clean_input($string) {
    if (is_string($string)) {
      return trim(ctf_sanitize_string(strip_tags(ctf_stripslashes($string))));
    } elseif (is_array($string)) {
      reset($string);
      while (list($key, $value) = each($string)) {
        $string[$key] = ctf_clean_input($value);
      }
      return $string;
    } else {
      return $string;
    }
}

function ctf_sanitize_string($string) {
    $string = preg_replace("/ +/", ' ', trim($string));
    return preg_replace("/[<>]/", '_', $string);
}

function ctf_stripslashes($string) {
        if (get_magic_quotes_gpc()) {
                return stripslashes($string);
        } else {
                return $string;
        }
}

function ctf_output_string($string) {
    return str_replace('"', '&quot;', $string);
}


// A function knowing about name case (i.e. caps on McDonald etc)
// $name = name_case($name);
function ctf_name_case($name) {
   if ($name == '') return '';
   $break = 0;
   $newname = strtoupper($name[0]);
   for ($i=1; $i < strlen($name); $i++) {
       $subed = substr($name, $i, 1);
       if (((ord($subed) > 64) && (ord($subed) < 123)) ||
           ((ord($subed) > 48) && (ord($subed) < 58))) {
           $word_check = substr($name, $i - 2, 2);
           if (!strcasecmp($word_check, 'Mc') || !strcasecmp($word_check, "O'")) {
               $newname .= strtoupper($subed);
           }else if ($break){
               $newname .= strtoupper($subed);
           }else{
               $newname .= strtolower($subed);
           }
             $break = 0;
       }else{
             // not a letter - a boundary
             $newname .= $subed;
             $break = 1;
       }
   }
   return $newname;
}

// checks proper email syntax (not perfect, none of these are, but this is the best I can find)
function ctf_validate_email($email) {

   //check for all the non-printable codes in the standard ASCII set,
   //including null bytes and newlines, and exit immediately if any are found.
   if (preg_match("/[\\000-\\037]/",$email)) {
      return false;
   }
   // regular expression used to perform the email check
   // http://fightingforalostcause.net/misc/2006/compare-email-regex.php
   //$pattern = "/^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.(aero|arpa|biz|com|coop|edu|gov|info|int|mil|museum|name|net|org|pro|travel|mobi|asia|cat|jobs|tel|[a-z][a-z])|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i";
   //$pattern = "/^([_a-zA-Z0-9-]+)(\.[_a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+)(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,4})$/i";
   $pattern = "/^[-_a-z0-9\'+*$^&%=~!?{}]++(?:\.[-_a-z0-9\'+*$^&%=~!?{}]+)*+@(?:(?![-.])[-a-z0-9.]+(?<![-.])\.[a-z]{2,6}|\d{1,3}(?:\.\d{1,3}){3})(?::\d++)?$/iD";
   if(!preg_match($pattern, $email)){
      return false;
   }
   // Validate the domain exists with a DNS check
   // if the checks cannot be made (soft fail over to true)
   list($user,$domain) = explode('@',$email);
   if( function_exists('checkdnsrr') ) {
      if( !checkdnsrr($domain,"MX") ) { // Linux: PHP 4.3.0 and higher & Windows: PHP 5.3.0 and higher
         return false;
      }
   }
   else if( function_exists("getmxrr") ) {
      if ( !getmxrr($domain, $mxhosts) ) {
         return false;
      }
   }
   return true;
} // end function ctf_validate_email

function ctf_forbidifnewlines($input) {
   if (
       stristr($input, "\r")  !== false ||
       stristr($input, "\n")  !== false ||
       stristr($input, "%0a") !== false ||
       stristr($input, "%0d") !== false) {
         echo "<h1>Input Forbidden</h1>";
         exit;
   }
}

function ctf_spamcheckpost() {
 global $domain, $domain_protect;

 if(!isset($_SERVER['HTTP_USER_AGENT'])){
     return 1;
  }

 // Make sure the form was indeed POST'ed:
 //  (requires your html form to use: action="post")
 if(!$_SERVER['REQUEST_METHOD'] == "POST"){
    return 2;
 }

  // Make sure the form was posted from an approved host name.
 if ($domain_protect) {
   // Host names from where the form is authorized to be posted from:
   if (is_array($domain)) {
      $domain = array_map(strtolower, $domain);
      $authHosts = $domain;
   } else {
      $domain =  strtolower($domain);
      $authHosts = array("$domain");
   }

   // Where have we been posted from?
   if( isset($_SERVER['HTTP_REFERER']) and trim($_SERVER['HTTP_REFERER']) != '' ) {
      $fromArray = parse_url(strtolower($_SERVER['HTTP_REFERER']));
      // Test to see if the $fromArray used www to get here.
      $wwwUsed = strpos($fromArray['host'], "www.");
      if(!in_array(($wwwUsed === false ? $fromArray['host'] : substr(stristr($fromArray['host'], '.'), 1)), $authHosts)){
         return 3;
      }
   }
 } // end if domain protect

 // check posted input for email injection attempts
 // Check for these common exploits
 // if you edit any of these do not break the syntax of the regex
 $input_expl = "/(content-type|mime-version|content-transfer-encoding|to:|bcc:|cc:|document.cookie|document.write|onmouse|onkey|onclick|onload)/i";
 // Loop through each POST'ed value and test if it contains one of the exploits fromn $input_expl:
 foreach($_POST as $k => $v){
   $v = strtolower($v);
   $v = str_replace('donkey','',$v); // fixes invalid input with "donkey" in string 
   if( preg_match($input_expl, $v) ){
     return 4;
   }
 }

 return 0;
}
?>

<!-- To add into your own page TRIM ending here -->

</body>
</html>